import * as i0 from '@angular/core';
import { Component, Inject, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1$2 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import { Helpers, Utils } from 'tnp-core/browser';
import { FiredevFullMaterialModule, SafePipe, FiredevFile, FiredevBinaryFile, FiredevTableComponent, FiredevTableModule } from './firedev-ui.mjs';
import * as i3 from '@ng-matero/extensions/split';
import { MtxSplitModule } from '@ng-matero/extensions/split';
import * as i1$1 from 'static-columns/browser';
import { StaticColumnsModule } from 'static-columns/browser';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i8 from 'ngx-ace-wrapper';
import { AceModule } from 'ngx-ace-wrapper';
import * as i9 from '@angular/material/button';
import * as i6 from '@angular/material/icon';
import * as i6$1 from '@angular/material/slide-toggle';
import 'tslib';
import 'firedev-storage/browser';
import 'rxjs';
import 'ngx-scrollbar';
import 'firedev/browser';
import '@angular/platform-browser';
import '@angular/cdk/a11y';
import '@angular/cdk/drag-drop';
import '@angular/cdk/scrolling';
import '@angular/cdk/stepper';
import '@angular/cdk/table';
import '@angular/cdk/tree';
import '@angular/material/autocomplete';
import '@angular/material/badge';
import '@angular/material/bottom-sheet';
import '@angular/material/card';
import '@angular/material/checkbox';
import '@angular/material/button-toggle';
import '@angular/material/stepper';
import '@angular/material/expansion';
import '@angular/material/grid-list';
import '@angular/material/list';
import '@angular/material/datepicker';
import '@angular/material/paginator';
import '@angular/material/progress-bar';
import '@angular/material/chips';
import '@angular/material/divider';
import '@angular/material/input';
import '@angular/material/menu';
import '@angular/material/core';
import '@angular/material/progress-spinner';
import '@angular/material/radio';
import '@angular/material/select';
import '@angular/material/sidenav';
import '@angular/material/slider';
import '@angular/material/snack-bar';
import '@angular/material/sort';
import '@angular/material/table';
import '@angular/material/tabs';
import '@angular/material/toolbar';
import '@angular/material/tooltip';
import '@angular/material/tree';
import 'ng2-logger/browser';
import 'brace';
import 'brace/mode/css';
import 'brace/mode/typescript';
import 'brace/theme/github';
import 'typescript-class-helpers/browser';
import '@ngx-formly/core';
import 'ngx-pipes';
import 'lodash';
import 'morphi/browser';
import '@angular/material/form-field';
import '@ng-matero/extensions/grid';
import 'axios';
import 'ngx-progressbar';
import 'ng2-rest/browser';
import '@ngneat/hot-toast';
import 'primeng/password';
import '@angular/core/rxjs-interop';
import '@ngx-formly/material';
import 'element-resize-detector';

var ViewMode;
(function (ViewMode) {
    ViewMode["Add"] = "Add";
    ViewMode["Edit"] = "Edit";
    ViewMode["Preview"] = "Preview";
})(ViewMode || (ViewMode = {}));
;
({}); // @--end-of-file-for-module=firedev-ui lib/shared/view-mode.ts

class FiredevCmsEditComponent {
    get filePath() {
        return this.data.entity?.src;
    }
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.ViewMode = ViewMode;
        this.height = window.innerHeight - 150;
        this.mode = data.mode;
        this.originalMode = this.mode;
        if (this.mode !== ViewMode.Add) {
            this.mediaType = Helpers.mediaTypeFromSrc(data.entity.src);
        }
    }
    async ngOnInit() {
        if (this.mediaType === 'image' || this.mediaType === 'audio') {
            this.url = window.URL.createObjectURL(this.data.entity.binaryData);
        }
        if (this.mediaType === 'text') {
            this.text = await Utils.binary.blobToText(this.data.entity.binaryData);
        }
    }
    ngOnDestroy() { }
    close() {
        this.dialogRef.close();
    }
    save() {
        console.log('saving file');
    }
    toogleMode() {
        this.mode = (this.mode === ViewMode.Preview) ? this.originalMode : ViewMode.Preview;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsEditComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.6", type: FiredevCmsEditComponent, isStandalone: true, selector: "firedev-cms-edit", ngImport: i0, template: "<button mat-icon-button\n        class=\"close-button\"\n        (click)=\"close()\">\n  <mat-icon>close</mat-icon>\n</button>\n<h1>\n  File Editor <mat-slide-toggle (change)=\"toogleMode()\">Preview mode</mat-slide-toggle>\n</h1>\n<div class=\"split-demo\"\n     [style.height.px]=\"height\">\n  <mtx-split direction=\"horizontal\"\n             [restrictMove]=\"true\"\n             [useTransition]=\"true\">\n    <mtx-split-pane [size]=\"100\">\n      <mtx-split direction=\"vertical\"\n                 [restrictMove]=\"true\">\n        <mtx-split-pane [size]=\"30\"\n                        #panel\n                        style=\"overflow: hidden;\">\n          <table width=\"100%\"\n                 height=\"100%\"\n                 align=\"center\"\n                 valign=\"center\">\n            <tr>\n              <td style=\"text-align: center;\"\n                  *ngIf=\"mode === ViewMode.Preview\">\n                <img [src]=\"url | safe:'url'\"\n                     #imagePreview\n                     [style.height.px]=\"panel.offsetHeight\"\n                     *ngIf=\"mediaType === 'image'\" />\n                <div *ngIf=\"mediaType === 'text'\"\n                     [innerHtml]=\"text | safe:'html'\"></div>\n                <audio *ngIf=\"mediaType === 'audio'\"\n                       [src]=\"url | safe:'url'\"\n                       id=\"audio\"\n                       controls> </audio>\n              </td>\n              <td *ngIf=\"mode !== ViewMode.Preview\">\n                <ace *ngIf=\"mediaType === 'text'\"\n                     [mode]=\"'typescript'\"\n                     [(value)]=\"text\"\n                     [theme]=\"'twilight'\"\n                     style=\"width: 100%; height: 100%;\"></ace>\n              </td>\n            </tr>\n          </table>\n        </mtx-split-pane>\n        <mtx-split-pane [size]=\"70\">\n          <p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium\n            doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore\n            veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam\n            voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia\n            consequuntur magni dolores eodolor sit amet, consectetur, adipisci velit, sed\n            quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam\n            quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam\n            corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis\n            autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil\n            molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>\n        </mtx-split-pane>\n      </mtx-split>\n    </mtx-split-pane>\n  </mtx-split>\n</div>\n<br>\n<columns-container>\n  <column grow>\n\n\n  </column>\n  <column [width]=\"200\">\n    <button mat-raised-button\n            (click)=\"save()\">save</button>\n  </column>\n</columns-container>\n", styles: [":host{display:block}.close-button{position:absolute;top:20px;right:30px}.split-demo{border:1px solid}textarea{margin:0!important;padding:0!important;border:0px!important;outline:0px!important;width:100%;height:100%;min-width:100%;min-height:100%}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "ngmodule", type: MtxSplitModule }, { kind: "component", type: i3.MtxSplit, selector: "mtx-split", inputs: ["color", "direction", "unit", "gutterSize", "gutterStep", "restrictMove", "useTransition", "disabled", "dir", "gutterDblClickDuration"], outputs: ["dragStart", "dragEnd", "gutterClick", "gutterDblClick", "transitionEnd"], exportAs: ["mtxSplit"] }, { kind: "directive", type: i3.MtxSplitPane, selector: "mtx-split-pane, [mtx-split-pane]", inputs: ["order", "size", "minSize", "maxSize", "lockSize", "visible"], exportAs: ["mtxSplitPane"] }, { kind: "ngmodule", type: FiredevFullMaterialModule }, { kind: "component", type: i9.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i9.MatIconButton, selector: "button[mat-icon-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i6.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: i6$1.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex"], exportAs: ["matSlideToggle"] }, { kind: "ngmodule", type: StaticColumnsModule }, { kind: "component", type: i1$1.ColumnsComponent, selector: "columns-container" }, { kind: "component", type: i1$1.ColumnComponent, selector: "column", inputs: ["width"] }, { kind: "directive", type: i1$1.DirectiveGrow, selector: "[grow]" }, { kind: "pipe", type: SafePipe, name: "safe" }, { kind: "ngmodule", type: AceModule }, { kind: "component", type: i8.AceComponent, selector: "ace", inputs: ["value", "disabled", "mode", "theme", "config", "useAceClass"], outputs: ["blur", "focus", "copy", "paste", "change", "valueChange", "changeCursor", "changeSession", "changeSelection"], exportAs: ["ngxAce"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsEditComponent, decorators: [{
            type: Component,
            args: [{ selector: 'firedev-cms-edit', imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MtxSplitModule,
                        FiredevFullMaterialModule,
                        StaticColumnsModule,
                        SafePipe,
                        AceModule,
                    ], standalone: true, template: "<button mat-icon-button\n        class=\"close-button\"\n        (click)=\"close()\">\n  <mat-icon>close</mat-icon>\n</button>\n<h1>\n  File Editor <mat-slide-toggle (change)=\"toogleMode()\">Preview mode</mat-slide-toggle>\n</h1>\n<div class=\"split-demo\"\n     [style.height.px]=\"height\">\n  <mtx-split direction=\"horizontal\"\n             [restrictMove]=\"true\"\n             [useTransition]=\"true\">\n    <mtx-split-pane [size]=\"100\">\n      <mtx-split direction=\"vertical\"\n                 [restrictMove]=\"true\">\n        <mtx-split-pane [size]=\"30\"\n                        #panel\n                        style=\"overflow: hidden;\">\n          <table width=\"100%\"\n                 height=\"100%\"\n                 align=\"center\"\n                 valign=\"center\">\n            <tr>\n              <td style=\"text-align: center;\"\n                  *ngIf=\"mode === ViewMode.Preview\">\n                <img [src]=\"url | safe:'url'\"\n                     #imagePreview\n                     [style.height.px]=\"panel.offsetHeight\"\n                     *ngIf=\"mediaType === 'image'\" />\n                <div *ngIf=\"mediaType === 'text'\"\n                     [innerHtml]=\"text | safe:'html'\"></div>\n                <audio *ngIf=\"mediaType === 'audio'\"\n                       [src]=\"url | safe:'url'\"\n                       id=\"audio\"\n                       controls> </audio>\n              </td>\n              <td *ngIf=\"mode !== ViewMode.Preview\">\n                <ace *ngIf=\"mediaType === 'text'\"\n                     [mode]=\"'typescript'\"\n                     [(value)]=\"text\"\n                     [theme]=\"'twilight'\"\n                     style=\"width: 100%; height: 100%;\"></ace>\n              </td>\n            </tr>\n          </table>\n        </mtx-split-pane>\n        <mtx-split-pane [size]=\"70\">\n          <p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium\n            doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore\n            veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam\n            voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia\n            consequuntur magni dolores eodolor sit amet, consectetur, adipisci velit, sed\n            quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam\n            quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam\n            corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis\n            autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil\n            molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>\n        </mtx-split-pane>\n      </mtx-split>\n    </mtx-split-pane>\n  </mtx-split>\n</div>\n<br>\n<columns-container>\n  <column grow>\n\n\n  </column>\n  <column [width]=\"200\">\n    <button mat-raised-button\n            (click)=\"save()\">save</button>\n  </column>\n</columns-container>\n", styles: [":host{display:block}.close-button{position:absolute;top:20px;right:30px}.split-demo{border:1px solid}textarea{margin:0!important;padding:0!important;border:0px!important;outline:0px!important;width:100%;height:100%;min-width:100%;min-height:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i1.MatDialogRef }]; } });
;
({}); // @--end-of-file-for-module=firedev-ui lib/firedev-cms/firedev-cms-edit/firedev-cms-edit.component.ts

;
({}); // @--end-of-file-for-module=firedev-ui lib/firedev-cms/firedev-cms-edit/index.ts

class FiredevCmsListContainer {
    constructor(dialog) {
        this.dialog = dialog;
        this.FiredevFile = FiredevFile;
        this.FiredevBinaryFile = FiredevBinaryFile;
        this.columns = [
            {
                header: 'ID',
                field: 'id',
                maxWidth: 100,
            },
            {
                header: 'src',
                field: 'src',
                maxWidth: 250
            },
            {
                header: 'Actions',
                field: 'actions',
                width: '100px',
                pinned: 'right',
                right: '0px',
                type: 'button',
                buttons: [
                    {
                        type: 'icon',
                        text: 'edit',
                        icon: 'edit',
                        tooltip: 'Edit',
                        click: async (model) => {
                            const entity = await FiredevBinaryFile.loadBy(model.src);
                            this.dialog.open(FiredevCmsEditComponent, {
                                maxWidth: '100vw',
                                maxHeight: '100vh',
                                height: '100%',
                                width: '100%',
                                data: {
                                    entity,
                                    mode: ViewMode.Preview,
                                }
                            });
                        },
                    },
                ],
            },
        ];
    }
    async ngOnInit() {
    }
    add() {
        this.dialog.open(FiredevCmsEditComponent, {
            maxWidth: '100vw',
            maxHeight: '100vh',
            height: '100%',
            width: '100%',
            data: {
                mode: ViewMode.Add,
            }
        });
    }
    expansionRow(e) {
        console.log(e);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainer, deps: [{ token: i1.MatDialog }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.6", type: FiredevCmsListContainer, selector: "app-firedev-cms-list", ngImport: i0, template: "<!-- <firedev-table [entity]=\"FiredevFile\"\n               [allowedColumns]=\"['src','contentType']\"\n               [columns]=\"columns\"\n               [expansionTemplate]=\"expansionTpl\"\n               (expansionChange)=\"expansionRow($event)\">\n</firedev-table> -->\n\n<ng-template #expansionTpl\n             let-row>\n  hello from expansion {{row.src}}\n</ng-template>\n\n<firedev-table [entity]=\"FiredevBinaryFile\"\n               [allowedColumns]=\"['src']\"\n               [columns]=\"columns\"\n               (addingItem)=\"add()\"\n               >\n</firedev-table>\n\n", styles: [":host{display:block}\n"], dependencies: [{ kind: "component", type: FiredevTableComponent, selector: "firedev-table", inputs: ["pageNumber", "pageSize", "allowedColumns", "entity", "expansionTemplate", "rows", "columns", "pageSizeOptions"], outputs: ["expansionChange", "addingItem"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainer, decorators: [{
            type: Component,
            args: [{ selector: 'app-firedev-cms-list', template: "<!-- <firedev-table [entity]=\"FiredevFile\"\n               [allowedColumns]=\"['src','contentType']\"\n               [columns]=\"columns\"\n               [expansionTemplate]=\"expansionTpl\"\n               (expansionChange)=\"expansionRow($event)\">\n</firedev-table> -->\n\n<ng-template #expansionTpl\n             let-row>\n  hello from expansion {{row.src}}\n</ng-template>\n\n<firedev-table [entity]=\"FiredevBinaryFile\"\n               [allowedColumns]=\"['src']\"\n               [columns]=\"columns\"\n               (addingItem)=\"add()\"\n               >\n</firedev-table>\n\n", styles: [":host{display:block}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.MatDialog }]; } });
;
({}); // @--end-of-file-for-module=firedev-ui lib/firedev-cms/firedev-cms-list/firedev-cms-list.container.ts

const routes = [
    {
        path: '',
        component: FiredevCmsListContainer,
        pathMatch: 'full' // => when using variables in other routers
    },
];
class FiredevCmsListContainerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainerModule, declarations: [FiredevCmsListContainer], imports: [CommonModule,
            FiredevTableModule,
            StaticColumnsModule,
            FiredevFullMaterialModule, i1$2.RouterModule, FiredevCmsEditComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainerModule, imports: [CommonModule,
            FiredevTableModule,
            StaticColumnsModule,
            FiredevFullMaterialModule,
            RouterModule.forChild(routes),
            FiredevCmsEditComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.6", ngImport: i0, type: FiredevCmsListContainerModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FiredevTableModule,
                        StaticColumnsModule,
                        FiredevFullMaterialModule,
                        RouterModule.forChild(routes),
                        FiredevCmsEditComponent,
                    ],
                    declarations: [FiredevCmsListContainer],
                }]
        }] });
;
({}); // @--end-of-file-for-module=firedev-ui lib/firedev-cms/firedev-cms-list/firedev-cms-list.container.module.ts

export { FiredevCmsListContainerModule };
//# sourceMappingURL=firedev-ui-firedev-cms-list.container.module-1fa3f0db.mjs.map
