// @ts-nocheck
import { Firedev } from 'firedev/browser';
import { CoreModels } from 'tnp-core/browser';
import type { FiredevFileController } from './firedev-file.controller';
import { FiredevFileDefaultAs, IFiredevFileType } from './firedev-file.models';
import { FiredevFileCss } from './firedev-file-css/firedev-file-css';
/**
 * @deprecated
 */
export declare class FiredevFile extends Firedev.Base.Entity<any> {
    static ctrl: FiredevFileController;
    static from(obj: Omit<Partial<FiredevFile>, 'ctrl'>): FiredevFile & Partial<FiredevFile>;
    static empty(): FiredevFile & Partial<FiredevFile>;
    static uploadFiles(files: FileList | File[], options?: {
        dontRestoreBlob?: boolean;
    }): Promise<FiredevFile[]>;
    static getBloblessBy(src: string): Promise<FiredevFile>;
    static getLatestVersion(src: string): Promise<number>;
    static getBlobOnlyBy(src: string): Promise<Blob | (FiredevFile & Partial<FiredevFile>)>;
    private static is;
    private constructor();
    get hasEmptyBlob(): boolean;
    ctrl: FiredevFileController;
    /**
     * temporary file
     */
    file: File;
    /**
     * temporary file
     */
    text: string;
    id: string;
    src: string;
    css: FiredevFileCss;
    defaultViewAs: FiredevFileDefaultAs;
    contentType: CoreModels.ContentType;
    /**
     * automatic version increment
     */
    version: number;
    /**
    * Field is create when initing assets
    */
    isFromAssets: boolean;
    /**
     * Blob stored in database
     */
    blob: Blob | string;
    /**
     * file proper extension (when saved on disc)
     */
    get ext(): any;
    /**
     * General type of content (short alternative to mime):
     * text, audio, video, html, json, js
     */
    get type(): IFiredevFileType;
    getDefaultView(): FiredevFileDefaultAs;
    getContentType(): CoreModels.ContentType;
}