import { ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { FiredevAdmin } from './firedev-admin';
import { CdkDragEnd, Point } from '@angular/cdk/drag-drop';
import { BreakpointsService } from 'static-columns';
import { Subject } from 'rxjs';
import { FiredevAdminModeTab } from './models/firedev-admin-mode-tabs';
import { FiredevAdminService } from './firedev-admin-control.service';
export declare class FiredevAdminModeConfigurationComponent implements OnInit {
    private breakpointsService;
    $destroy: Subject<unknown>;
    readonly cdr: ChangeDetectorRef;
    readonly firedevAdminService: FiredevAdminService;
    readonly isDesktop: boolean;
    tabs: FiredevAdminModeTab[];
    admin: FiredevAdmin;
    isWebSQLMode: boolean;
    hideFiredevToolsInProduction: boolean;
    isIframe: boolean;
    height: number;
    openedOnce: boolean;
    reloading: boolean;
    showPasscode: boolean;
    passcode: string;
    message: string;
    dragPositionX: number;
    dragPositionY: number;
    dragPositionZero: Point;
    dragPosition: Point;
    selectedIndex: number;
    tabGroup: any;
    wasOpenDraggablePopup: boolean;
    firedevAdminModeConfigurationDataChanged: EventEmitter<any>;
    firedevAdminModeConfigurationData: any;
    get opened(): boolean;
    set opened(v: boolean);
    constructor(breakpointsService: BreakpointsService);
    reloadTabs(): void;
    ngOnInit(): Promise<void>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onResize(event: Event): void;
    toogle(): Promise<void>;
    toogleFullScreen(): Promise<void>;
    resetDrag(): void;
    moved(c: CdkDragEnd): void;
    scrollTabs(event: any): void;
}