import { FiredevAdminDB } from './firedev-admin-db';
import type { FiredevFile } from '../firedev-file';
import type { FiredevAdminModeConfigurationComponent } from './firedev-admin-mode-configuration.component';
export declare class FiredevAdmin {
    protected ENV?: any;
    cmp: FiredevAdminModeConfigurationComponent;
    scrollableEnabled: boolean;
    private onEditMode;
    onEditMode$: import("rxjs").Observable<unknown>;
    private onRegisterFileChange;
    private onRegisterFileChange$;
    private registeredFiles;
    selectedFileSrc: string;
    /**
     * Enable edit mode for each element on page
     */
    filesEditMode: boolean;
    adminPanelIsOpen: boolean;
    draggablePopupMode: boolean;
    draggablePopupModeFullScreen: boolean;
    /**
     * Property used in firedev
     */
    keepWebsqlDbDataAfterReload: boolean;
    /**
     * Property used in firedev
     */
    db: FiredevAdminDB;
    get selectedFile(): FiredevFile;
    set selectedFile(v: FiredevFile);
    get currentFiles(): FiredevFile[];
    constructor(ENV?: any);
    setEditMode(value: boolean): void;
    setKeepWebsqlDbDataAfterReload(value: boolean): void;
    onRegisterFile(): import("rxjs").Observable<void>;
    register(file: FiredevFile): void;
    unregister(file: FiredevFile): void;
    enabledTabs: any[];
    hide(): void;
    show(): void;
    logout(): void;
}