/// <reference types="node" />
import { Utils } from 'tnp-core';
import { FiredevBinaryFile } from '../firedev-binary-file';
import type { FiredevBinaryFileController } from '../firedev-binary-file.controller';
import { CoreModels } from 'tnp-core';
import { Blob } from 'buffer';
/**
 * Backend (websql also) methods for FiredevBinaryFile
 *
 * + use entites injected controllers to access other backends
 * + don't use controllers methods/properties here
 */
export declare class FiredevBinaryFileBackend {
    private ctrl;
    private readonly project;
    private readonly assetsPath;
    static for(ctrl: FiredevBinaryFileController): FiredevBinaryFileBackend;
    private get repo();
    private get repository();
    private constructor();
    getByUrl(relativePathOnServer: any): Promise<FiredevBinaryFile<Utils.DbBinaryFormat>>;
    countEntities(): Promise<void>;
    saveFileNodejs(data: CoreModels.UploadedBackendFile | Buffer | string | Blob, relativePath: string): Promise<void>;
    getFileNodejs(relativePath: string): Promise<Buffer>;
    saveFileWebsql(file: File | Blob, relativePath: string): Promise<void>;
    getFileWebsql(relativePath: string): Promise<Blob>;
    getAssets(): Promise<string[]>;
    getAssetFromWebsqlMode(assetPath: string): Promise<Blob>;
}
