"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiredevBinaryFileController = void 0;
var tslib_1 = require("tslib");
//#region imports
var firedev_1 = require("firedev");
var tnp_core_1 = require("tnp-core");
var firedev_binary_file_1 = require("./firedev-binary-file");
var tnp_core_2 = require("tnp-core");
var firedev_db_entity_1 = require("./firedev-db-entity");
var firedev_binary_file_backend_1 = require("./backend/firedev-binary-file-backend");
//#endregion
/**
 * Isomorphic Controller for FiredevBinaryFile
 *
 * + only create here isomorphic controller methods
 * + use this.backend for any backend/db operations
 */
var FiredevBinaryFileController = exports.FiredevBinaryFileController = /** @class */ (function (_super) {
    tslib_1.__extends(FiredevBinaryFileController, _super);
    function FiredevBinaryFileController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        //#region @websql
        _this.backend = firedev_binary_file_backend_1.FiredevBinaryFileBackend.for(_this);
        return _this;
        //#endregion
    }
    //#endregion
    //#endregion
    //#region methods
    //#region methods / save
    FiredevBinaryFileController.prototype.save = function (binaryData, relativePathOnServer) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                console.log('SAVING', binaryData);
                //#region @backend
                if (tnp_core_2.Helpers.isBuffer(binaryData)) {
                    this.backend.saveFileNodejs(binaryData, relativePathOnServer);
                }
                if (tnp_core_2._.isString(binaryData)) {
                    this.backend.saveFileNodejs(binaryData, relativePathOnServer);
                }
                if (tnp_core_2.Helpers.isBlob(binaryData)) {
                    this.backend.saveFileNodejs(binaryData, relativePathOnServer);
                }
                return [2 /*return*/];
            });
        });
    };
    //#endregion
    //#region methods / load
    FiredevBinaryFileController.prototype.load = function (relativePathOnServer, loadAs) {
        if (loadAs === void 0) { loadAs = tnp_core_2.Utils.DbBinaryFormatEnum.Blob; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                return [2 /*return*/, void 0];
            });
        });
    };
    //#endregion
    //#region methods / save file
    FiredevBinaryFileController.prototype.saveFile = function (file, relativePathOnServer) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                return [2 /*return*/, void 0];
            });
        });
    };
    //#endregion
    //#region methods / save blob
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    //#endregion
    //#region methods / save text
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    //#endregion
    //#region methods / get text
    /* */
    /* */
    /* */
    /* */
    /* */
    //#endregion
    //#region methods / get blob
    /* */
    /* */
    /* */
    /* */
    /* */
    //#endregion
    //#region methods / get file
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    /* */
    //#endregion
    //#region methods / init example data
    //#region @websql
    FiredevBinaryFileController.prototype.initExampleDbData = function (isWorker) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var repo, assets, filesToSave, index, src, file;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        repo = this.repository;
                        // @LAST simplyfi this and make api for access files/entities easy
                        // - load entity (with binary data)
                        // - save entity (with binary data)
                        /* tests
                        //#region hamster image
                        const blobStringHamster = (await import('./media-examples/hamster-image')).default;
                        const hammyBlob = await Utils.binary.base64toDbBinaryFormat(blobStringHamster);
                    
                        const hammyFile = FiredevBinaryFile.from({
                          src: '/src/assets/upload/hamsters/my-hammy.jpeg',
                          binaryData: hammyBlob as Blob,
                        });
                        await FiredevBinaryFile.save(hammyFile);
                        //#endregion
                    
                    
                        //#region my nigga blbo
                        const myniggaHtml = `Hell my niga <strong>html</strong>`;
                    
                        const myNiggaFile = FiredevBinaryFile.from({
                          src: '/src/assets/upload/post-templates/post.html',
                          binaryData: myniggaHtml
                        })
                        await FiredevBinaryFile.save(myNiggaFile);
                        //#endregion
                    
                    
                        //#region samble sound
                        const sound =  (await import('./media-examples/binary-sound')).default;
                        const soundBlob = await Utils.binary.base64toDbBinaryFormat(sound);
                        const soundFile = FiredevBinaryFile.from({
                          src: '/src/assets/upload/sounds/sound1.ogg',
                          binaryData: soundBlob as Blob,
                        });
                        await FiredevBinaryFile.save(soundFile);
                        //#endregion
                    */
                        //#region @websql
                        if (ENV.dontLoadAssets) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.backend.getAssets()];
                    case 1:
                        assets = _a.sent();
                        filesToSave = [];
                        for (index = 0; index < assets.length; index++) {
                            src = assets[index];
                            file = firedev_binary_file_1.FiredevBinaryFile.from({
                                src: "/src/".concat(src),
                                /* */
                                /* */
                            });
                            filesToSave.push(file);
                        }
                        return [4 /*yield*/, repo.save(filesToSave)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    //#endregion
    //#endregion
    //#region methods / _ get blob
    FiredevBinaryFileController.prototype._getBlob = function (relativePathOnServer) {
        var _this = this;
        //#region @websqlFunc
        return function (req, res) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var restoreFileFromFileSystem, blob_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        relativePathOnServer = (relativePathOnServer);
                        if (!tnp_core_2.Helpers.isNode) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.backend.getFileNodejs(relativePathOnServer)];
                    case 1:
                        restoreFileFromFileSystem = _a.sent();
                        return [4 /*yield*/, tnp_core_2.Utils.binary.bufferToBlob(restoreFileFromFileSystem)];
                    case 2:
                        blob_1 = _a.sent();
                        blob_1 = blob_1.slice(0, blob_1.size, tnp_core_1.CoreModels.mimeTypes[tnp_core_2.path.extname(relativePathOnServer)]);
                        return [2 /*return*/, blob_1];
                    case 3: 
                    //#endregion
                    return [2 /*return*/, void 0];
                }
            });
        }); };
        //#endregion
    };
    //#endregion
    //#region methods / save form data
    FiredevBinaryFileController.prototype.saveFormData = function (formData, relativePathOnServer) {
        var _this = this;
        //#region @websqlFunc
        return function (req, res) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var files;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        relativePathOnServer = (relativePathOnServer);
                        console.log({
                            formData: formData,
                            relativePathOnServer: relativePathOnServer,
                            req: req,
                            res: res
                        });
                        /* */
                        /* */
                        /* */
                        //#region @backend
                        // @ts-ignore
                        if (!req.files || Object.keys(req.files).length === 0) {
                            console.log("NOTHING TO UPLOAD");
                            res.status(400).send('No files were uploaded.');
                            return [2 /*return*/];
                        }
                        files = tnp_core_2._.values(req['files']);
                        return [4 /*yield*/, this.backend.saveFileNodejs(tnp_core_2._.first(files), relativePathOnServer)
                            //#endregion
                        ];
                    case 1:
                        _a.sent();
                        //#endregion
                        return [2 /*return*/, void 0];
                }
            });
        }); };
        //#endregion
    };
    //#endregion
    //#region methods / get entity by url
    FiredevBinaryFileController.prototype.getByUrl = function (relativePathOnServer) {
        var _this = this;
        //#region @websqlFunc
        return function (req, res) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.backend.getByUrl(relativePathOnServer)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        //#endregion
    };
    //#endregion
    //#endregion
    //#region get all db entities
    FiredevBinaryFileController.prototype.getAllEntities = function () {
        var _this = this;
        //#region @websqlFunc
        return function (req, res) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var tables, index, table, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!tnp_core_2.Helpers.isNode) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.connection.query("\n        SELECT\n        name\n    FROM\n        sqlite_schema\n    WHERE\n        type ='table' AND\n        name NOT LIKE 'sqlite_%';\n           ")];
                    case 1:
                        tables = _b.sent();
                        _b.label = 2;
                    case 2:
                        //#endregion
                        tables = (tables || []).map(function (c) { return firedev_db_entity_1.FiredevDbEntity.from(c); });
                        index = 0;
                        _b.label = 3;
                    case 3:
                        if (!(index < tables.length)) return [3 /*break*/, 6];
                        table = tables[index];
                        _a = table;
                        return [4 /*yield*/, this.connection.query("\n        SELECT c.name FROM pragma_table_info('".concat(table.name, "') c;\n        "))];
                    case 4:
                        _a.columns = (_b.sent()).map(function (c) { return c.name; });
                        _b.label = 5;
                    case 5:
                        index++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/, tables];
                }
            });
        }); };
        //#endregion
    };
    tslib_1.__decorate([
        firedev_1.Firedev.Http.GET({
            overridResponseType: 'blob',
            path: '/get/blob'
        }),
        tslib_1.__param(0, firedev_1.Firedev.Http.Param.Query('by-path')),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [String]),
        tslib_1.__metadata("design:returntype", Object)
    ], FiredevBinaryFileController.prototype, "_getBlob", null);
    tslib_1.__decorate([
        firedev_1.Firedev.Http.POST({
            overrideContentType: 'multipart/form-data',
            path: '/blob/read'
        }),
        tslib_1.__param(0, firedev_1.Firedev.Http.Param.Body()),
        tslib_1.__param(1, firedev_1.Firedev.Http.Param.Query('filepath')),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object, String]),
        tslib_1.__metadata("design:returntype", Object)
    ], FiredevBinaryFileController.prototype, "saveFormData", null);
    tslib_1.__decorate([
        firedev_1.Firedev.Http.GET({
            path: '/get/blobless/enitiy/by'
        }),
        tslib_1.__param(0, firedev_1.Firedev.Http.Param.Query('by-path')),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [String]),
        tslib_1.__metadata("design:returntype", Object)
    ], FiredevBinaryFileController.prototype, "getByUrl", null);
    tslib_1.__decorate([
        firedev_1.Firedev.Http.GET(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", Object)
    ], FiredevBinaryFileController.prototype, "getAllEntities", null);
    FiredevBinaryFileController = tslib_1.__decorate([
        firedev_1.Firedev.Controller({
            //#region controller options
            className: 'FiredevBinaryFileController',
            entity: firedev_binary_file_1.FiredevBinaryFile,
            //#endregion
        })
    ], FiredevBinaryFileController);
    return FiredevBinaryFileController;
}(firedev_1.Firedev.Base.Controller));
//# sourceMappingURL=firedev-binary-file.controller.js.map