import { Firedev } from 'firedev';
import { Utils } from 'tnp-core';
import type { FiredevBinaryFileController } from './firedev-binary-file.controller';
import { FiredevBinaryFileNonColumnsKeys } from './firedev-binary-file.models';
/**
 * Entity class for FiredevBinaryFile
 *
 * + use static methods to for backend access encapsulation
 */
export declare class FiredevBinaryFile<T = Utils.DbBinaryFormat> extends Firedev.Base.Entity<any> {
    static ctrl: FiredevBinaryFileController;
    static from(obj: Omit<Partial<FiredevBinaryFile>, FiredevBinaryFileNonColumnsKeys>): FiredevBinaryFile<Utils.DbBinaryFormat>;
    static $getAll(): import("rxjs").Observable<FiredevBinaryFile<Utils.DbBinaryFormat>[]>;
    static save(file: FiredevBinaryFile): Promise<void>;
    static loadBy(src: string): Promise<FiredevBinaryFile>;
    static getAll(): Promise<FiredevBinaryFile<Utils.DbBinaryFormat>[]>;
    static emptyModel(): FiredevBinaryFile<Utils.DbBinaryFormat>;
    private constructor();
    id: string;
    src?: string;
    isInIndexedDbCache?: boolean;
    loadAs: Utils.DbBinaryFormatEnum;
    ctrl: FiredevBinaryFileController;
    binaryData?: T;
    clone(options?: {
        propsToOmit: (keyof FiredevBinaryFile)[];
    }): FiredevBinaryFile;
}