"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiredevBinaryFile = void 0;
var tslib_1 = require("tslib");
//#region imports
var firedev_1 = require("firedev");
var tnp_core_1 = require("tnp-core");
var rxjs_1 = require("rxjs");
var firedev_binary_file_constants_1 = require("./firedev-binary-file.constants");
//#endregion
//#endregion
/**
 * Entity class for FiredevBinaryFile
 *
 * + use static methods to for backend access encapsulation
 */
var FiredevBinaryFile = exports.FiredevBinaryFile = /** @class */ (function (_super) {
    tslib_1.__extends(FiredevBinaryFile, _super);
    //#endregion
    //#region constructor
    function FiredevBinaryFile() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return _super.apply(this, tslib_1.__spreadArray([], tslib_1.__read(args), false)) || this;
    }
    FiredevBinaryFile_1 = FiredevBinaryFile;
    FiredevBinaryFile.from = function (obj) {
        obj = tnp_core_1._.merge(firedev_binary_file_constants_1.DEF_MODEL_VALUE_FIREDEV_BINARY_FILE, tnp_core_1._.omit(obj, firedev_binary_file_constants_1.FIREDEV_BINARY_FILE_NON_COL_KEY_ARR));
        return tnp_core_1._.merge(new FiredevBinaryFile_1(), obj);
    };
    FiredevBinaryFile.$getAll = function () {
        var _a;
        return (_a = this.ctrl.getAll().received) === null || _a === void 0 ? void 0 : _a.observable.pipe((0, rxjs_1.map)(function (data) { var _a; return ((_a = data.body) === null || _a === void 0 ? void 0 : _a.json) || []; }));
    };
    FiredevBinaryFile.save = function (file) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var repo, fileForSave;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        repo = this.ctrl.repository;
                        fileForSave = tnp_core_1._.merge(new FiredevBinaryFile_1(), tnp_core_1._.cloneDeep(file));
                        delete fileForSave.binaryData;
                        return [4 /*yield*/, repo.save(fileForSave)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.ctrl.save(file.binaryData, file.src)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FiredevBinaryFile.loadBy = function (src) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                /* */
                /* */
                /* */
                /* */
                /* */
                /* */
                // TODO  backend thing
                return [2 /*return*/, void 0];
            });
        });
    };
    FiredevBinaryFile.getAll = function () {
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var data;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.ctrl.getAll().received];
                    case 1:
                        data = _b.sent();
                        return [2 /*return*/, ((_a = data === null || data === void 0 ? void 0 : data.body) === null || _a === void 0 ? void 0 : _a.json) || []];
                }
            });
        });
    };
    FiredevBinaryFile.emptyModel = function () {
        return FiredevBinaryFile_1.from(firedev_binary_file_constants_1.DEF_MODEL_VALUE_FIREDEV_BINARY_FILE);
    };
    //#endregion
    //#region methods
    FiredevBinaryFile.prototype.clone = function (options) {
        var propsToOmit = (options || { propsToOmit: firedev_binary_file_constants_1.FIREDEV_BINARY_FILE_NON_COL_KEY_ARR }).propsToOmit;
        return tnp_core_1._.merge(new FiredevBinaryFile_1(), tnp_core_1._.omit(this, propsToOmit));
    };
    var FiredevBinaryFile_1;
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Generated()
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevBinaryFile.prototype, "id", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: 'varchar',
            length: 250,
            default: '',
            unique: true,
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevBinaryFile.prototype, "src", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: 'varchar',
            length: 10,
            default: tnp_core_1.Utils.DbBinaryFormatEnum.Blob,
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevBinaryFile.prototype, "loadAs", void 0);
    FiredevBinaryFile = FiredevBinaryFile_1 = tslib_1.__decorate([
        firedev_1.Firedev.Entity({
            //#region entity options
            className: 'FiredevBinaryFile',
            defaultModelValues: firedev_binary_file_constants_1.DEF_MODEL_VALUE_FIREDEV_BINARY_FILE,
            //#endregion
        }),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], FiredevBinaryFile);
    return FiredevBinaryFile;
}(firedev_1.Firedev.Base.Entity));
//# sourceMappingURL=firedev-binary-file.js.map