"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiredevFileBackend = void 0;
var tslib_1 = require("tslib");
//#region imports
//#region @backend
var tnp_core_1 = require("tnp-core");
//#endregion
var tnp_core_2 = require("tnp-core");
var axios_1 = require("axios");
var tnp_1 = require("tnp");
var tnp_helpers_1 = require("tnp-helpers");
var firedev_file_1 = require("../firedev-file");
//#endregion
/**
 * @deprecated
 *
 * Backend (websql also) methods for MyEntity
 *
 * + use entites injected controllers to access other backends
 * + don't use controllers methods/properties here
 */
var FiredevFileBackend = /** @class */ (function () {
    function FiredevFileBackend(ctrl) {
        this.ctrl = ctrl;
    }
    //#region initialization
    FiredevFileBackend.for = function (ctrl) { return new FiredevFileBackend(ctrl); };
    Object.defineProperty(FiredevFileBackend.prototype, "repo", {
        get: function () {
            return this.ctrl.repository;
        },
        enumerable: false,
        configurable: true
    });
    //#endregion
    //#region restore blob for file
    FiredevFileBackend.prototype.restoreBlobWhenFileFromAsset = function (file) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var repo, shouldRestoreBlob, proj, relativeFilePath, absFilePath, buffer, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        repo = this.ctrl.repository;
                        shouldRestoreBlob = (file.isFromAssets && file.hasEmptyBlob);
                        if (!shouldRestoreBlob) return [3 /*break*/, 3];
                        if (!tnp_helpers_1.Helpers.isNode) return [3 /*break*/, 3];
                        proj = tnp_1.Project.ins.From(process.cwd());
                        relativeFilePath = file.src.replace("/assets-for/".concat(proj.name, "/"), '/');
                        if (!proj.__isSmartContainerTarget) return [3 /*break*/, 1];
                        return [3 /*break*/, 3];
                    case 1:
                        if (!proj.__isStandaloneProject) return [3 /*break*/, 3];
                        absFilePath = "".concat(proj.location, "/src").concat(relativeFilePath);
                        buffer = tnp_core_1.fse.readFileSync(absFilePath).buffer;
                        _a = file;
                        return [4 /*yield*/, tnp_core_2.Utils.binary.arrayBufferToBlob(buffer, 'text/plain')];
                    case 2:
                        _a.blob = _b.sent();
                        _b.label = 3;
                    case 3: return [2 /*return*/, file];
                }
            });
        });
    };
    //#endregion
    //#region init example data
    FiredevFileBackend.prototype.initExampleDbData = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var repo, assets, filesToSave, index, src, file;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //#region @websql
                        if (ENV.dontLoadAssets) {
                            return [2 /*return*/];
                        }
                        repo = this.ctrl.repository;
                        return [4 /*yield*/, this.getAssets()];
                    case 1:
                        assets = _a.sent();
                        filesToSave = [];
                        for (index = 0; index < assets.length; index++) {
                            src = assets[index];
                            file = firedev_file_1.FiredevFile.from({
                                src: "/".concat(src),
                                isFromAssets: true,
                            });
                            filesToSave.push(file);
                        }
                        return [4 /*yield*/, repo.save(filesToSave)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    //#endregion
    //#region get assets
    /**
     *
     * @deprecated
     */
    FiredevFileBackend.prototype.getAssets = function () {
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var proj, assetsList, basename, data;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        //#region websqlFunc
                        //#region @backend
                        if (tnp_helpers_1.Helpers.isNode) {
                            proj = tnp_1.Project.ins.From(process.cwd());
                            assetsList = tnp_helpers_1.Helpers.readJson(proj.pathFor("tmp-apps-for-dist/".concat(proj.name, "/src/assets/assets-list.json")));
                            // console.log({ proj, env: global['ENV'], assetsList })
                            return [2 /*return*/, assetsList];
                        }
                        basename = (((_a = window === null || window === void 0 ? void 0 : window.ENV) === null || _a === void 0 ? void 0 : _a.basename) ? (window.ENV.basename) : '');
                        return [4 /*yield*/, (0, axios_1.default)({
                                // @ts-ignore
                                url: "".concat(basename).concat(basename.endsWith('/') ? '' : '/', "assets/assets-list.json"),
                                method: 'GET',
                                responseType: 'json'
                            })];
                    case 1:
                        data = _b.sent();
                        return [2 /*return*/, data.data];
                }
            });
        });
    };
    return FiredevFileBackend;
}());
exports.FiredevFileBackend = FiredevFileBackend;
//# sourceMappingURL=firedev-file-backend.js.map