"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiredevFile = void 0;
var tslib_1 = require("tslib");
//#region imports
var firedev_1 = require("firedev");
var tnp_core_1 = require("tnp-core");
var tnp_helpers_1 = require("tnp-helpers");
var firedev_file_css_1 = require("./firedev-file-css/firedev-file-css");
var firedev_file_constants_1 = require("./firedev-file.constants");
//#endregion
//#endregion
/**
 * @deprecated
 */
var FiredevFile = exports.FiredevFile = /** @class */ (function (_super) {
    tslib_1.__extends(FiredevFile, _super);
    //#endregion
    //#endregion
    //#region constructor
    function FiredevFile() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return _super.apply(this, tslib_1.__spreadArray([], tslib_1.__read(args), false)) || this;
    }
    FiredevFile_1 = FiredevFile;
    //#endregion
    //#region static / from
    FiredevFile.from = function (obj) {
        var instance = FiredevFile_1.empty(); // @ts-ignore
        var clonedObj = tnp_core_1._.cloneDeep(obj);
        instance = tnp_core_1._.merge(instance, clonedObj);
        if (!instance.defaultViewAs) {
            instance.defaultViewAs = instance.getDefaultView();
        }
        if (!instance.contentType) {
            instance.contentType = instance.getContentType();
        }
        return instance;
    };
    //#endregion
    //#region static / empty
    FiredevFile.empty = function () {
        return tnp_core_1._.merge(new FiredevFile_1(), firedev_file_constants_1.defaultModelValues);
    };
    //#endregion
    //#region static / upload files
    FiredevFile.uploadFiles = function (files, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var dontRestoreBlob, firedevFiles, index, formData, file, resp, firedevFile, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        dontRestoreBlob = (options || {}).dontRestoreBlob;
                        firedevFiles = [];
                        index = 0;
                        _b.label = 1;
                    case 1:
                        if (!(index < files.length)) return [3 /*break*/, 6];
                        formData = new FormData();
                        file = files[index];
                        formData.append("file".concat(index + 1), file);
                        return [4 /*yield*/, this.ctrl.upload(formData).received];
                    case 2:
                        resp = _b.sent();
                        firedevFile = resp.body.json;
                        if (!!dontRestoreBlob) return [3 /*break*/, 4];
                        _a = firedevFile;
                        return [4 /*yield*/, tnp_core_1.Utils.binary.fileToBlob(file)];
                    case 3:
                        _a.blob = _b.sent();
                        _b.label = 4;
                    case 4:
                        firedevFiles.push(firedevFile);
                        _b.label = 5;
                    case 5:
                        index++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, firedevFiles];
                }
            });
        });
    };
    //#endregion
    //#region static / get blob-less by src
    FiredevFile.getBloblessBy = function (src) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var data;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (src.startsWith('http')) {
                            return [2 /*return*/, FiredevFile_1.from({
                                    src: src,
                                    version: 0,
                                })];
                        }
                        src = encodeURIComponent(src);
                        return [4 /*yield*/, this.ctrl.getBloblessBy(src).received];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data.body.json];
                }
            });
        });
    };
    //#endregion
    //#region static / get latest version by src
    FiredevFile.getLatestVersion = function (src) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var data;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        src = encodeURIComponent(src);
                        return [4 /*yield*/, this.ctrl.getLatestVersion(src).received];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, Number(data.body.text)];
                }
            });
        });
    };
    //#endregion
    //#region static / get blob-only by src
    FiredevFile.getBlobOnlyBy = function (src) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var blob, data;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!src.startsWith('http')) return [3 /*break*/, 2];
                        return [4 /*yield*/, tnp_core_1.Utils.binary.getBlobFrom(src)];
                    case 1:
                        blob = _a.sent();
                        return [2 /*return*/, FiredevFile_1.from({
                                src: src,
                                blob: blob,
                                version: 0,
                            })];
                    case 2:
                        src = encodeURIComponent(src);
                        return [4 /*yield*/, this.ctrl.getBlobOnlyBy(src).received];
                    case 3:
                        data = _a.sent();
                        return [2 /*return*/, data.body.blob];
                }
            });
        });
    };
    //#endregion
    //#region static / is
    FiredevFile.is = function (extensionOrContentType, isWhat) {
        if (isWhat === 'css') {
            // @ts-ignore
            isWhat = 'text/css';
        }
        if (isWhat === 'js') {
            // @ts-ignore
            isWhat = 'text/javascript';
        }
        if (isWhat === 'html') {
            // @ts-ignore
            isWhat = 'text/html';
        }
        if (isWhat === 'text') {
            // @ts-ignore
            isWhat = 'text/html';
        }
        if (isWhat === 'json') {
            // @ts-ignore
            isWhat = 'application/json';
        }
        var isExt = extensionOrContentType.startsWith('.');
        if (isExt) {
            var contentType = tnp_core_1.CoreModels.MimeTypesObj[extensionOrContentType];
            return contentType === null || contentType === void 0 ? void 0 : contentType.startsWith("".concat(isWhat));
        }
        return extensionOrContentType.startsWith("".concat(isWhat));
    };
    Object.defineProperty(FiredevFile.prototype, "hasEmptyBlob", {
        //#endregion
        //#region fields & getters
        get: function () {
            return tnp_core_1._.isNil(this.blob);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FiredevFile.prototype, "ext", {
        //#endregion
        //#region fields & getters / ext
        /**
         * file proper extension (when saved on disc)
         */
        get: function () {
            var _a;
            if (this.defaultViewAs === 'css-tag') {
                return '.css';
            }
            var realSrc = tnp_core_1._.first((_a = this.src) === null || _a === void 0 ? void 0 : _a.split('?'));
            return realSrc ? tnp_core_1.path.extname(realSrc) : '';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FiredevFile.prototype, "type", {
        //#endregion
        //#region fields & getters / type
        /**
         * General type of content (short alternative to mime):
         * text, audio, video, html, json, js
         */
        get: function () {
            for (var index = 0; index < firedev_file_constants_1.FiredevFileTypeArr.length; index++) {
                var element = firedev_file_constants_1.FiredevFileTypeArr[index];
                if (FiredevFile_1.is(this.ext, element)) {
                    return element;
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    //#endregion
    //#endregion
    //#region methods
    //#region methods / get default view
    FiredevFile.prototype.getDefaultView = function () {
        if (this.type === 'js') {
            return 'script-tag';
        }
        if (this.type === 'css') {
            return 'css-tag';
        }
        if (this.type === 'audio') {
            return 'audio-tag';
        }
        if (this.type === 'video') {
            return 'video-tag';
        }
        if (this.type === 'image') {
            return 'img-tag';
        }
        if (this.type === 'html') {
            return 'html-rendered';
        }
        if (this.type === 'json') {
            return 'json-editor';
        }
    };
    //#endregion
    //#region methods / get content type
    FiredevFile.prototype.getContentType = function () {
        return tnp_core_1.CoreModels.MimeTypesObj[this.ext];
    };
    var FiredevFile_1;
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Generated()
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevFile.prototype, "id", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: 'varchar',
            length: 150,
            default: null,
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevFile.prototype, "src", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.SimpleJson()
        //#endregion
        ,
        tslib_1.__metadata("design:type", firedev_file_css_1.FiredevFileCss)
    ], FiredevFile.prototype, "css", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: 'varchar',
            length: 20,
            default: null,
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevFile.prototype, "defaultViewAs", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: 'varchar',
            length: 40,
            default: null,
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", String)
    ], FiredevFile.prototype, "contentType", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Version()
        //#endregion
        ,
        tslib_1.__metadata("design:type", Number)
    ], FiredevFile.prototype, "version", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Boolean(false)
        //#endregion
        ,
        tslib_1.__metadata("design:type", Boolean)
    ], FiredevFile.prototype, "isFromAssets", void 0);
    tslib_1.__decorate([
        firedev_1.Firedev.Orm.Column.Custom({
            type: tnp_helpers_1.Helpers.isWebSQL ? 'text' : 'blob',
            default: null,
            transformer: {
                /**
                 *
                 * @param value from entity type
                 * @returns
                 */
                to: function (value) {
                    // console.log('TO', value)
                    // if (value instanceof Blob) {
                    //   console.log(`TO (BLOB IS BLOB):`, value)
                    //   return await Helpers.binary.blobToBase64(value)
                    // }
                    // console.log(`TO (BLOB IS NOT BLOB):`, value)
                    // return
                    // if (value instanceof Blob) {
                    //   Helpers.binary.arrayBufferToBlob
                    // }
                    // return Buffer.from(value);
                    return value;
                },
                /**
                 *
                 * @param value in database type
                 * @returns
                 */
                from: function (value) {
                    // console.log('FROM', value)
                    // if (_.isString(value)) {
                    //   console.log(`FROM (value is string):`, value)
                    //   return await Helpers.binary.base64toBlob(value);
                    // }
                    // console.log(`FROM (value is not string):`, value)
                    // return value.toString();
                    return value;
                }
            }
        })
        //#endregion
        ,
        tslib_1.__metadata("design:type", Object)
    ], FiredevFile.prototype, "blob", void 0);
    FiredevFile = FiredevFile_1 = tslib_1.__decorate([
        firedev_1.Firedev.Entity({
            //#region entity config
            className: 'FiredevFile',
            defaultModelMapping: {
                'css': 'FiredevFileCss',
            },
            //#endregion
        }),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], FiredevFile);
    return FiredevFile;
}(firedev_1.Firedev.Base.Entity));
//# sourceMappingURL=firedev-file.js.map