import { ChangeDetectorRef, DestroyRef, ElementRef, OnInit } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
export interface FiredevSessionPasscodeModel {
    passcode: string;
}
export type FiredevSessionPasscodeForm = {
    [prop in keyof FiredevSessionPasscodeModel]: FormControl<FiredevSessionPasscodeModel[prop]>;
};
export declare class FiredevSessionPasscodeComponent implements OnInit {
    private element;
    private domSanitizer;
    private cdr;
    destroyRef: DestroyRef;
    passcode: string;
    message: string;
    safeMessage: SafeHtml;
    private lastPasscode;
    display: string;
    form: FormGroup<FiredevSessionPasscodeForm>;
    constructor(element: ElementRef<HTMLElement>, domSanitizer: DomSanitizer, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    submit({ passcode }: Partial<FiredevSessionPasscodeModel>): void;
    private isPasscodeOK;
    ngAfterViewInit(): void;
    focus(): void;
    hide(): void;
    show(): void;
    clear(): void;
    onKeyup(event: KeyboardEvent & {
        target: {
            value: string;
        };
    }): void;
}