// @ts-nocheck
import { Utils } from 'tnp-core/websql';
import { FiredevBinaryFile } from '../firedev-binary-file';
import type { FiredevBinaryFileController } from '../firedev-binary-file.controller';
/**
 * Backend (websql also) methods for FiredevBinaryFile
 *
 * + use entites injected controllers to access other backends
 * + don't use controllers methods/properties here
 */
export declare class FiredevBinaryFileBackend {
    private ctrl;
    static for(ctrl: FiredevBinaryFileController): FiredevBinaryFileBackend;
    private get repo();
    private get repository();
    private constructor();
    getByUrl(relativePathOnServer: any): Promise<FiredevBinaryFile<Utils.DbBinaryFormatForBrowser>>;
    countEntities(): Promise<void>;
    saveFileWebsql(file: File | Blob, relativePath: string): Promise<void>;
    getFileWebsql(relativePath: string): Promise<Blob>;
    getAssets(): Promise<string[]>;
    getAssetFromWebsqlMode(assetPath: string): Promise<Blob>;
}