// @ts-nocheck
import type { FiredevBinaryFile } from "./firedev-binary-file";
import { DEF_MODEL_VALUE_FIREDEV_BINARY_FILE } from "./firedev-binary-file.constants";
import { NumberColumn, PropsEntitySQL, QueryTable, StringColumn, BasicColumn } from "firedev-type-sql/websql";
export type FiredevBinaryFileNonColumnsKeys = 'ctrl' | 'blob' | 'clone';
export type IFiredevBinaryFile = Partial<FiredevBinaryFile>;
export type IFiredevBinaryFileTable = PropsEntitySQL<typeof DEF_MODEL_VALUE_FIREDEV_BINARY_FILE>;
export declare class FiredevBinaryFileTable extends QueryTable<FiredevBinaryFile, number> implements IFiredevBinaryFileTable {
    id: NumberColumn<this>;
    src: StringColumn<this>;
    loadAs: StringColumn<this>;
    isInIndexedDbCache: BasicColumn<this, unknown>;
    /**
     * dont use as column
     * @deprecated
     */
    binaryData: BasicColumn<this, unknown>;
}
export declare const FIREDEV_BINARY_FILE: FiredevBinaryFileTable;